<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" /><meta name="generator" content="Docutils 0.17.1: http://docutils.sourceforge.net/" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Files &mdash; Heiwa  documentation</title>
      <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="_static/css/theme.css" type="text/css" />
      <link rel="stylesheet" href="_static/custom.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="./" id="documentation_options" src="_static/documentation_options.js"></script>
        <script src="_static/jquery.js"></script>
        <script src="_static/underscore.js"></script>
        <script src="_static/doctools.js"></script>
    <script src="_static/js/theme.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="Forums" href="heiwa.views.forum.html" />
    <link rel="prev" title="Categories" href="heiwa.views.category.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
            <a href="index.html" class="icon icon-home"> Heiwa
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Contents:</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="performance.html">Performance</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="heiwa.html">API Documentation</a><ul class="current">
<li class="toctree-l2 current"><a class="reference internal" href="heiwa.html#subpackages">Subpackages</a><ul class="current">
<li class="toctree-l3"><a class="reference internal" href="heiwa.authentication.html">Authentication</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.constants.html">Statuses</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.database.html">Database</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.json_ld.html">JSON-LD</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.enums.html">Enums</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.error_handlers.html">Error handlers</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.exceptions.html">Exceptions</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.limiter.html">Rate limiter</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.tasks.html">Tasks</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.types.html">Abstract types</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.validators.html">Validators</a></li>
<li class="toctree-l3 current"><a class="reference internal" href="heiwa.views.html">API views</a><ul class="current">
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.category.html">Categories</a></li>
<li class="toctree-l4 current"><a class="current reference internal" href="#">Files</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.forum.html">Forums</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.group.html">Groups</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.guest.html">Guests</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.message.html">Messages</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.meta.html">Meta information</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.notification.html">Notifications</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.oidc.html">OIDC</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.post.html">Posts</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.statistic.html">Statistics</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.thread.html">Threads</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.user.html">Users</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.utils.html">Utilities</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="heiwa.html#module-heiwa">Root</a></li>
</ul>
</li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="index.html">Heiwa</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="index.html" class="icon icon-home"></a> &raquo;</li>
          <li><a href="heiwa.html">API Documentation</a> &raquo;</li>
          <li><a href="heiwa.views.html">API views</a> &raquo;</li>
      <li>Files</li>
      <li class="wy-breadcrumbs-aside">
            <a href="_sources/heiwa.views.file.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="module-heiwa.views.file">
<span id="files"></span><h1>Files<a class="headerlink" href="#module-heiwa.views.file" title="Permalink to this headline"></a></h1>
<p>API views for <a class="reference internal" href="heiwa.database.html#heiwa.database.File" title="heiwa.database.File"><code class="xref py py-class docutils literal notranslate"><span class="pre">File</span></code></a>s.</p>
<div class="admonition warning">
<p class="admonition-title">Warning</p>
<p>Ideally, files would never be handled all at once and read in chunks. This,
however, is not possible with the simple way uploads are currently handled -
a lot of memory may thus be used during uploads.</p>
<p><em>Note - I may come back to this in the future.</em></p>
</div>
<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.file.check_file_changed">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.file.</span></span><span class="sig-name descname"><span class="pre">check_file_changed</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">old_file_location</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">str</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">new_file</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">bytes</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">bool</span></span></span><a class="reference internal" href="_modules/heiwa/views/file.html#check_file_changed"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.file.check_file_changed" title="Permalink to this definition"></a></dt>
<dd><p>Checks whether or not the <code class="docutils literal notranslate"><span class="pre">old_file_location</span></code>’s contents and <code class="docutils literal notranslate"><span class="pre">new_file</span></code>
match.</p>
<p>So as to avoid using a lot of memory, the comparison is done in chunks of
8 KiB. This is also the reason why this is a separate function.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>old_file_location</strong> – The location of the old file.</p></li>
<li><p><strong>new_file</strong> – The new file, in the form of <code class="docutils literal notranslate"><span class="pre">bytes</span></code>.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>The result of the check.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.file.create">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.file.</span></span><span class="sig-name descname"><span class="pre">create</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">Tuple</span><span class="p"><span class="pre">[</span></span><span class="pre">flask.wrappers.Response</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">int</span><span class="p"><span class="pre">]</span></span></span></span><a class="reference internal" href="_modules/heiwa/views/file.html#create"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.file.create" title="Permalink to this definition"></a></dt>
<dd><p>Creates a file with the given <code class="docutils literal notranslate"><span class="pre">name</span></code> and base64-encoded <code class="docutils literal notranslate"><span class="pre">content</span></code>.</p>
<dl class="field-list simple">
<dt class="field-odd">Raises</dt>
<dd class="field-odd"><ul class="simple">
<li><p><a class="reference internal" href="heiwa.exceptions.html#heiwa.exceptions.APIFileNotAllowedType" title="heiwa.exceptions.APIFileNotAllowedType"><strong>heiwa.exceptions.APIFileNotAllowedType</strong></a> – Raised when the guessed media
(MIME) type of the file does not match any of those found in the
<code class="docutils literal notranslate"><span class="pre">FILE_TYPES</span></code> config key.</p></li>
<li><p><a class="reference internal" href="heiwa.exceptions.html#heiwa.exceptions.APIFileExceededMaxTotalSize" title="heiwa.exceptions.APIFileExceededMaxTotalSize"><strong>heiwa.exceptions.APIFileExceededMaxTotalSize</strong></a> – Raised when the current
<code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.user</span></code>’s
<a class="reference internal" href="heiwa.database.html#heiwa.database.User.file_total_size" title="heiwa.database.User.file_total_size"><code class="xref py py-attr docutils literal notranslate"><span class="pre">file_total_size</span></code></a>, combined
with the size of the file being uploaded, would exceed the limit set by
the <code class="docutils literal notranslate"><span class="pre">FILE_MAX_TOTAL_SIZE</span></code> config key. The new total size is given in
the exception’s details.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>Metadata about the newly uploaded file (stored in the database),
with the HTTP <code class="docutils literal notranslate"><span class="pre">201</span></code> status code. The file itself is not returned.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.file.delete">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.file.</span></span><span class="sig-name descname"><span class="pre">delete</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">id_</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">uuid.UUID</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">Tuple</span><span class="p"><span class="pre">[</span></span><span class="pre">flask.wrappers.Response</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">int</span><span class="p"><span class="pre">]</span></span></span></span><a class="reference internal" href="_modules/heiwa/views/file.html#delete"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.file.delete" title="Permalink to this definition"></a></dt>
<dd><p>Deletes the file with the requested <code class="docutils literal notranslate"><span class="pre">id_</span></code>, including its contents.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>id</strong> – The <a class="reference internal" href="heiwa.database.html#heiwa.database.File.id" title="heiwa.database.File.id"><code class="xref py py-attr docutils literal notranslate"><span class="pre">id</span></code></a> of the file.</p>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>, with the HTTP <code class="docutils literal notranslate"><span class="pre">204</span></code> status code.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.file.edit">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.file.</span></span><span class="sig-name descname"><span class="pre">edit</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">id_</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">uuid.UUID</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">Tuple</span><span class="p"><span class="pre">[</span></span><span class="pre">flask.wrappers.Response</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">int</span><span class="p"><span class="pre">]</span></span></span></span><a class="reference internal" href="_modules/heiwa/views/file.html#edit"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.file.edit" title="Permalink to this definition"></a></dt>
<dd><p>Updates the file with the requested <code class="docutils literal notranslate"><span class="pre">id_</span></code>’s metadata - information about
it stored in the database.</p>
<p>Right now, that is only the <a class="reference internal" href="heiwa.database.html#heiwa.database.File.name" title="heiwa.database.File.name"><code class="xref py py-attr docutils literal notranslate"><span class="pre">name</span></code></a>, but
the endpoint is structured in the same way as other <code class="docutils literal notranslate"><span class="pre">edit</span></code> ones to keep
access as universal as possible. <code class="xref py py-attr docutils literal notranslate"><span class="pre">type</span> <span class="pre">&lt;heiwa.database.File.type&gt;</span> <span class="pre">and</span>
<span class="pre">:attr:`size</span> <span class="pre">&lt;heiwa.database.File.size&gt;`</span></code> could both easily be faked and it’s
possible to guess them programatically, so editing them is not possible.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>id</strong> – The <a class="reference internal" href="heiwa.database.html#heiwa.database.File.id" title="heiwa.database.File.id"><code class="xref py py-attr docutils literal notranslate"><span class="pre">id</span></code></a> of the file.</p>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><p><a class="reference internal" href="heiwa.exceptions.html#heiwa.exceptions.APIFileUnchanged" title="heiwa.exceptions.APIFileUnchanged"><strong>heiwa.exceptions.APIFileUnchanged</strong></a> – Raised when no attributes of the
file’s metadata have been visibly changed.</p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>The updated file metadata, with the HTTP <code class="docutils literal notranslate"><span class="pre">200</span></code> status code.</p>
</dd>
</dl>
<div class="admonition seealso">
<p class="admonition-title">See also</p>
<p>For editing the file’s contents, <a class="reference internal" href="#heiwa.views.file.edit_contents" title="heiwa.views.file.edit_contents"><code class="xref py py-func docutils literal notranslate"><span class="pre">edit_contents()</span></code></a></p>
</div>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.file.edit_contents">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.file.</span></span><span class="sig-name descname"><span class="pre">edit_contents</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">id_</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">uuid.UUID</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">Tuple</span><span class="p"><span class="pre">[</span></span><span class="pre">flask.wrappers.Response</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">int</span><span class="p"><span class="pre">]</span></span></span></span><a class="reference internal" href="_modules/heiwa/views/file.html#edit_contents"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.file.edit_contents" title="Permalink to this definition"></a></dt>
<dd><p>Updates the file with the requested <code class="docutils literal notranslate"><span class="pre">id_</span></code>’s contents, stored on the
filesystem.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>id</strong> – The <a class="reference internal" href="heiwa.database.html#heiwa.database.File.id" title="heiwa.database.File.id"><code class="xref py py-attr docutils literal notranslate"><span class="pre">id</span></code></a> of the file.</p>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><ul class="simple">
<li><p><a class="reference internal" href="heiwa.exceptions.html#heiwa.exceptions.APIFileUnchanged" title="heiwa.exceptions.APIFileUnchanged"><strong>heiwa.exceptions.APIFileUnchanged</strong></a> – Raised when the contents of the
file have not been changed.</p></li>
<li><p><a class="reference internal" href="heiwa.exceptions.html#heiwa.exceptions.APIFileExceededMaxTotalSize" title="heiwa.exceptions.APIFileExceededMaxTotalSize"><strong>heiwa.exceptions.APIFileExceededMaxTotalSize</strong></a> – Raised when the new
<a class="reference internal" href="heiwa.database.html#heiwa.database.User.file_total_size" title="heiwa.database.User.file_total_size"><code class="xref py py-attr docutils literal notranslate"><span class="pre">file_total_size</span></code></a> of the
current <code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.user</span></code> would exceed the limit set in the
<code class="docutils literal notranslate"><span class="pre">FILE_MAX_TOTAL_SIZE</span></code> config key.</p></li>
</ul>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p><code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>, with the HTTP <code class="docutils literal notranslate"><span class="pre">200</span></code> status code.</p>
</dd>
</dl>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>The updated contents are not returned so as to preserve bandwidth. This
is also the case with other similar endpoints, including those for user
avatars.</p>
</div>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.file.get_file">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.file.</span></span><span class="sig-name descname"><span class="pre">get_file</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">id_</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">uuid.UUID</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">session</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">sqlalchemy.orm.session.Session</span><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">user</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><a class="reference internal" href="heiwa.database.html#heiwa.database.User" title="heiwa.database.user.User"><span class="pre">heiwa.database.user.User</span></a><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><a class="reference internal" href="heiwa.database.html#heiwa.database.File" title="heiwa.database.file.File"><span class="pre">heiwa.database.file.File</span></a></span></span><a class="reference internal" href="_modules/heiwa/views/file.html#get_file"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.file.get_file" title="Permalink to this definition"></a></dt>
<dd><p>Gets the file with the given <code class="docutils literal notranslate"><span class="pre">id_</span></code>. If it doesn’t exist or the <code class="docutils literal notranslate"><span class="pre">user</span></code>
does not have the permission to view it, an exception is raised instead.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>id</strong> – The <a class="reference internal" href="heiwa.database.html#heiwa.database.File.id" title="heiwa.database.File.id"><code class="xref py py-attr docutils literal notranslate"><span class="pre">id</span></code></a> of the file to find.</p></li>
<li><p><strong>session</strong> – The SQLAlchemy session to execute the selection query with.
Defaults to <code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.sa_session</span></code> if <code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>.</p></li>
<li><p><strong>user</strong> – The <a class="reference internal" href="heiwa.database.html#heiwa.database.User" title="heiwa.database.User"><code class="xref py py-class docutils literal notranslate"><span class="pre">User</span></code></a> who should have
permission to view the file. Defaults to <code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.user</span></code> if
<code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>.</p></li>
</ul>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><p><a class="reference internal" href="heiwa.exceptions.html#heiwa.exceptions.APIFileNotFound" title="heiwa.exceptions.APIFileNotFound"><strong>heiwa.exceptions.APIFileNotFound</strong></a> – Raised when the file does simply
not exist, or the given user does not have permission to view it.</p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>The file.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.file.list_">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.file.</span></span><span class="sig-name descname"><span class="pre">list_</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">Tuple</span><span class="p"><span class="pre">[</span></span><span class="pre">flask.wrappers.Response</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">int</span><span class="p"><span class="pre">]</span></span></span></span><a class="reference internal" href="_modules/heiwa/views/file.html#list_"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.file.list_" title="Permalink to this definition"></a></dt>
<dd><p>Gets the metadata of all files that the current <code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.user</span></code> is
allowed to view. If there is a filter requested, they must also match it.</p>
<dl class="field-list simple">
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>The list of file metadata, with the HTTP <code class="docutils literal notranslate"><span class="pre">200</span></code> status code.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.file.mass_delete">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.file.</span></span><span class="sig-name descname"><span class="pre">mass_delete</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">Tuple</span><span class="p"><span class="pre">[</span></span><span class="pre">flask.wrappers.Response</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">int</span><span class="p"><span class="pre">]</span></span></span></span><a class="reference internal" href="_modules/heiwa/views/file.html#mass_delete"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.file.mass_delete" title="Permalink to this definition"></a></dt>
<dd><p>Deletes all files the current <code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.user</span></code> is allowed to, including
their contents stored on the filesystem. If there is a filter requested, they
must also match it.</p>
<dl class="field-list simple">
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p><code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>, with the HTTP <code class="docutils literal notranslate"><span class="pre">204</span></code> status code.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.file.mass_edit">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.file.</span></span><span class="sig-name descname"><span class="pre">mass_edit</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">Tuple</span><span class="p"><span class="pre">[</span></span><span class="pre">flask.wrappers.Response</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">int</span><span class="p"><span class="pre">]</span></span></span></span><a class="reference internal" href="_modules/heiwa/views/file.html#mass_edit"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.file.mass_edit" title="Permalink to this definition"></a></dt>
<dd><p>Updates all files <code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.user</span></code> is allowed to - including the
contents. If there is a filter requested, they must also match it.</p>
<dl class="field-list simple">
<dt class="field-odd">Raises</dt>
<dd class="field-odd"><ul class="simple">
<li><p><a class="reference internal" href="heiwa.exceptions.html#heiwa.exceptions.APIFileNotAllowedType" title="heiwa.exceptions.APIFileNotAllowedType"><strong>heiwa.exceptions.APIFileNotAllowedType</strong></a> – Raised when the contents are
being updated, and their guessed media (MIME) does not match any of those
found in the <code class="docutils literal notranslate"><span class="pre">FILE_TYPES</span></code> config key.</p></li>
<li><p><a class="reference internal" href="heiwa.exceptions.html#heiwa.exceptions.APIFileExceededMaxTotalSize" title="heiwa.exceptions.APIFileExceededMaxTotalSize"><strong>heiwa.exceptions.APIFileExceededMaxTotalSize</strong></a> – Raised when the contents
are being updated and their total size, subtracted from the existing files’
sizes and added to the current <code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.user</span></code>’s
<a class="reference internal" href="heiwa.database.html#heiwa.database.User.file_total_size" title="heiwa.database.User.file_total_size"><code class="xref py py-attr docutils literal notranslate"><span class="pre">file_total_size</span></code></a> would exceed
the limit set in the <code class="docutils literal notranslate"><span class="pre">FILE_MAX_TOTAL_SIZE</span></code> config key. The new total
size is given in the exception’s details.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>, with the HTTP <code class="docutils literal notranslate"><span class="pre">204</span></code> status code.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.file.validate_file_type">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.file.</span></span><span class="sig-name descname"><span class="pre">validate_file_type</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">file_</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">bytes</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">get</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">bool</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">False</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">str</span><span class="p"><span class="pre">]</span></span></span></span><a class="reference internal" href="_modules/heiwa/views/file.html#validate_file_type"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.file.validate_file_type" title="Permalink to this definition"></a></dt>
<dd><p>Validates whether or not the given <code class="docutils literal notranslate"><span class="pre">file_</span></code> is one of the types given in
the <code class="docutils literal notranslate"><span class="pre">FILE_TYPES</span></code> config key using <code class="docutils literal notranslate"><span class="pre">libmagic</span></code>. If the validation is
successful, gives back the guessed type.</p>
<p>Only the first 4 KiB (or less) of the file are considered when its type is
being guessed. This means large files will not unnecessarily use twice the
memory space during the time they’re processed.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>file</strong> – The file’s bytes.</p></li>
<li><p><strong>get</strong> – Whether or not to also return the guessed type.</p></li>
</ul>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><p><a class="reference internal" href="heiwa.exceptions.html#heiwa.exceptions.APIFileNotAllowedType" title="heiwa.exceptions.APIFileNotAllowedType"><strong>heiwa.exceptions.APIFileNotAllowedType</strong></a> – Raised when the file is not
one of the allowed media (MIME) types. The guessed type is given in the
exception’s details.</p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>The guessed type, if <code class="docutils literal notranslate"><span class="pre">get</span></code> is <code class="xref py py-data docutils literal notranslate"><span class="pre">True</span></code>. Otherwise, returns
<code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.file.view">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.file.</span></span><span class="sig-name descname"><span class="pre">view</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">id_</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">uuid.UUID</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">Tuple</span><span class="p"><span class="pre">[</span></span><span class="pre">flask.wrappers.Response</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">int</span><span class="p"><span class="pre">]</span></span></span></span><a class="reference internal" href="_modules/heiwa/views/file.html#view"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.file.view" title="Permalink to this definition"></a></dt>
<dd><p>Gets the file with the requested <code class="docutils literal notranslate"><span class="pre">id_</span></code>’s metadata - its object stored
in the database.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>id</strong> – The <a class="reference internal" href="heiwa.database.html#heiwa.database.File.id" title="heiwa.database.File.id"><code class="xref py py-attr docutils literal notranslate"><span class="pre">id</span></code></a> of the file.</p>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>The metadata, with the HTTP <code class="docutils literal notranslate"><span class="pre">200</span></code> status code.</p>
</dd>
</dl>
<div class="admonition seealso">
<p class="admonition-title">See also</p>
<p>To view the file’s contents, <a class="reference internal" href="#heiwa.views.file.view_contents" title="heiwa.views.file.view_contents"><code class="xref py py-func docutils literal notranslate"><span class="pre">view_contents()</span></code></a></p>
</div>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.file.view_allowed_actions_instance">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.file.</span></span><span class="sig-name descname"><span class="pre">view_allowed_actions_instance</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">id_</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">uuid.UUID</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">Tuple</span><span class="p"><span class="pre">[</span></span><span class="pre">flask.wrappers.Response</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">int</span><span class="p"><span class="pre">]</span></span></span></span><a class="reference internal" href="_modules/heiwa/views/file.html#view_allowed_actions_instance"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.file.view_allowed_actions_instance" title="Permalink to this definition"></a></dt>
<dd><p>Gets all actions that the current <code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.user</span></code> is allowed to
perform on the file with the given <code class="docutils literal notranslate"><span class="pre">id_</span></code>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>id</strong> – The <a class="reference internal" href="heiwa.database.html#heiwa.database.File.id" title="heiwa.database.File.id"><code class="xref py py-attr docutils literal notranslate"><span class="pre">id</span></code></a> of the file.</p>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><p><a class="reference internal" href="heiwa.exceptions.html#heiwa.exceptions.APIFileNotFound" title="heiwa.exceptions.APIFileNotFound"><strong>heiwa.exceptions.APIFileNotFound</strong></a> – Raised when the file was
not found.</p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>The list of allowed actions, with the <code class="docutils literal notranslate"><span class="pre">200</span></code> HTTP status code.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.file.view_allowed_actions_static">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.file.</span></span><span class="sig-name descname"><span class="pre">view_allowed_actions_static</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">Tuple</span><span class="p"><span class="pre">[</span></span><span class="pre">flask.wrappers.Response</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">int</span><span class="p"><span class="pre">]</span></span></span></span><a class="reference internal" href="_modules/heiwa/views/file.html#view_allowed_actions_static"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.file.view_allowed_actions_static" title="Permalink to this definition"></a></dt>
<dd><p>Gets all actions that the current <code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.user</span></code> is allowed to
perform of any file, irrespective of which one it is.</p>
<dl class="field-list simple">
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>The list of allowed actions, with the <code class="docutils literal notranslate"><span class="pre">200</span></code> HTTP status code.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.file.view_contents">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.file.</span></span><span class="sig-name descname"><span class="pre">view_contents</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">id_</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">uuid.UUID</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">Tuple</span><span class="p"><span class="pre">[</span></span><span class="pre">flask.wrappers.Response</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">int</span><span class="p"><span class="pre">]</span></span></span></span><a class="reference internal" href="_modules/heiwa/views/file.html#view_contents"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.file.view_contents" title="Permalink to this definition"></a></dt>
<dd><p>Gets the file with the requested <code class="docutils literal notranslate"><span class="pre">id_</span></code>’s contents - stored on the
filesystem, instead of the database.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>id</strong> – The <a class="reference internal" href="heiwa.database.html#heiwa.database.File.id" title="heiwa.database.File.id"><code class="xref py py-attr docutils literal notranslate"><span class="pre">id</span></code></a> of the file.</p>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>The contents, associated with their media (MIME) type and the
HTTP <code class="docutils literal notranslate"><span class="pre">200</span></code> status code.</p>
</dd>
</dl>
</dd></dl>

</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="heiwa.views.category.html" class="btn btn-neutral float-left" title="Categories" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="heiwa.views.forum.html" class="btn btn-neutral float-right" title="Forums" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p></p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>